### runtime library
	.text
exit:
	li	$a0, 0
	li	$v0, 10
	syscall
print:
	li	$v0, 4
	syscall
	jr	$ra
print_int:
	li	$v0, 1
	syscall
	jr	$ra

	.data
eol:
	.asciiz "\n"

### gtcd(a, b, trace)
	.data
Sgtcd_th:			# table header
	.asciiz	"    a\t|   b\t| a mod b\n---------------------------\n"
Sgtcd_td1:			# table data, first cell
	.asciiz "   "
Sgtcd_tdn:			# table data, other cells
	.asciiz "\t|   "
		
	.text
gtcd:
	move	$s0, $a0	# a in $s0
	move	$s1, $a1	# b in $s1
	move	$s3, $a2	# trace in $s3
	move	$s7, $ra	# return address in $s7
	
	beqz	$s3, Lgtcd_loop
	beqz	$s1, Lgtcd_loop_end
	la	$a0, Sgtcd_th
	jal	print
Lgtcd_loop:
	beqz	$s1, Lgtcd_loop_end
	rem	$s2, $s0, $s1
	beqz	$s3, Lgtcd_loop_trace_end
Lgtcd_loop_trace:
	la	$a0, Sgtcd_td1	# trace a
	jal	print
	move	$a0, $s0
	jal	print_int
	la	$a0, Sgtcd_tdn	# trace b
	jal	print
	move	$a0, $s1
	jal	print_int
	la	$a0, Sgtcd_tdn	# trace a % b
	jal	print
	move	$a0, $s2
	jal	print_int
	li	$a0, eol	# end of trace
	jal	print
Lgtcd_loop_trace_end:
	move	$s0, $s1
	move	$s1, $s2
	j	Lgtcd_loop
Lgtcd_loop_end:
	move	$v0, $s0
	jr	$s7

### gtcd(2097, 42, 1):	compute and trace gtcd(2097, 42)
main:
	li	$a0, 2097
	li	$a1, 42
	li	$a2, 1
	jal	gtcd

	move	$a0, $v0
	jal	print_int
	li	$a0, eol
	jal	print

end:		
	j	exit
