### runtime library
	.text
exit:
	li	$a0, 0
	li	$v0, 10
	syscall
print:
	li	$v0, 4
	syscall
	jr	$ra
print_int:
	li	$v0, 1
	syscall
	jr	$ra

	.data
eol:
	.asciiz "\n"

### modexp(g, e, m, trace)
	.data
Smodexp_th:			# table header
	.asciiz	"   e_i\t|   h\t|   g\n------------------------\n"
Smodexp_td1:			# table data, first cell
	.asciiz	"   "
Smodexp_tdn:			# table data, other cells
	.asciiz	"\t|   "
	
	.text
modexp:
	move	$s0, $a0	# g in $s0
	move	$s1, $a1	# e in $s1
	move	$s2, $a2	# m in $s2
	li	$s3, 1		# h = 1 in $s3
	move	$s6, $a3	# trace in $s6
	move	$s7, $ra	# return address in $s7

	beqz	$s6, Lmodexp_loop
	beqz	$s1, Lmodexp_loop_end
	la	$a0, Smodexp_th
	jal	print
Lmodexp_loop:
	beqz	$s1, Lmodexp_loop_end
	and	$s4, $s1, 0x1	# e_i in $s4
	beqz	$s4, Lmodexp_loop_0
	mul	$t0, $s0, $s3
	rem	$s3, $t0, $s2	# h := g * h mod m
Lmodexp_loop_0:
	mul	$t0, $s0, $s0
	rem	$s0, $t0, $s2

	beqz	$s6, Lmodexp_loop_trace_end
Lmodexp_loop_trace:
	la	$a0, Smodexp_td1	# trace e_i
	jal	print
	move	$a0, $s4
	jal	print_int
	la	$a0, Smodexp_tdn	# trace h
	jal	print
	move	$a0, $s3
	jal	print_int
	la	$a0, Smodexp_tdn	# trace g
	jal	print
	move	$a0, $s0
	jal	print_int
	la	$a0, eol
	jal	print
Lmodexp_loop_trace_end:
		
	srl	$s1, $s1, 1
	
	j	Lmodexp_loop
Lmodexp_loop_end:
	move	$v0, $s3
	jr	$s7

### modexp(8, 23, 19, 1):	compute and trace 8 ^ 23 [19]
main:
	li	$a0, 8
	li	$a1, 23
	li	$a2, 19
	li	$a3, 1
	jal	modexp
	move	$s0, $v0

 	move	$a0, $s0
 	jal	print_int
 	la	$a0, eol
 	jal	print
	
	j	exit
